package com.zcloud.personnel.positioning.web;

import com.zcloud.personnel.positioning.api.OpenapiConfigServiceI;
import com.zcloud.personnel.positioning.dto.OpenapiConfigAddCmd;
import com.zcloud.personnel.positioning.dto.OpenapiConfigPageQry;
import com.zcloud.personnel.positioning.dto.OpenapiConfigUpdateCmd;
import com.zcloud.personnel.positioning.dto.clientobject.OpenapiConfigCO;
import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * web-adapter
 *
 * @Author fangjiakai
 * @Date 2026-07-07
 */
@Api(tags = "人员定位第三方接口配置")
@RequestMapping("/${application.gateway}/openapiConfig")
@RestController
@AllArgsConstructor
public class OpenapiConfigController {
    private final OpenapiConfigServiceI openapiConfigService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<OpenapiConfigCO> add(@Validated @RequestBody OpenapiConfigAddCmd cmd) {
        fillCorpinfo(cmd);
        return openapiConfigService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    public PageResponse<OpenapiConfigCO> page(@RequestBody OpenapiConfigPageQry qry) {
        return openapiConfigService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<OpenapiConfigCO> listAll() {
        return MultiResponse.of(openapiConfigService.listAll());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<OpenapiConfigCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(openapiConfigService.queryById(id));
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        openapiConfigService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("删除多个")
    @DeleteMapping("/ids")
    public Response removeBatch(@RequestParam Long[] ids) {
        openapiConfigService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody OpenapiConfigUpdateCmd cmd) {
        fillCorpinfo(cmd);
        openapiConfigService.edit(cmd);
        return SingleResponse.buildSuccess();
    }

    private void fillCorpinfo(OpenapiConfigAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }

    private void fillCorpinfo(OpenapiConfigUpdateCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }
}
